// сonst и final

// оба эти типа данных схожи, но все же есть различия


void main(){
  //const и final используются для объявления переменных с неизменяемыми значениями.
  // Однако, есть разница между ними:

  //1. final:
    // Переменная final может быть инициализирована только один раз,
    // разовое присваивание значения происходит во время выполнения программы.
    // После инициализации, значение переменной final не может быть изменено.
    
    // Значение переменной final может быть известно во время компиляции или во время выполнения,
    // в зависимости от инициализации.
    
    // Переменные final динамически получают тип данных, когда им присваивается значения.


  //2. const:
    // const переменная должна быть инициализирована уже во время компиляции,
    // а не во время выполнения программы.
    // Значение const переменной не может быть изменено после инициализации.

    // const статически проверяется во время компиляции и часто ограничен некоторыми дополнительными ограничениями
    // (например, значение должно быть литералом времени компиляции).

    // const переменные позволяют использовать как ключ в Map или Set.

  //Вот несколько примеров для демонстрации разницы между const и final:

  final int finalValue = 10;
  //finalValue = 20; // Ошибка! Значение не может быть изменено

  const int constValue = 10;
  //constValue = 20; // Ошибка! Значение не может быть изменено

  final dynamic finalDynamicValue = 10;
  //finalDynamicValue = 'Hello'; // Правильно, тип изменен

  const dynamic constDynamicValue = 10;
  //constDynamicValue = 'Hello'; // Ошибка! Значение не может быть изменено

  const name = 'Halolol';
  //name = "123"; // Ошибка! Значение не может быть изменено

  const os = "android";
  const age = 26;
  const value = 2+2;

  const double cost = 5.55;
  const cllectionOfDouble = [12.33, cost]; // так как cost статический и не может менять свое значение, то его можно поместить в коллекцию

  double getDoubleValue(){
    return 123.322;
  }

  //const someValue = getDoubleValue(); // ошибка, мы не можем присвоить вычисляемое значение нашей константе, так как она должна быть статической
  final someValue = getDoubleValue(); // не ошибка, так как final -у можно присваивать вычесленное значение, но в дальнейшем мы не имеем право его менять

  // Вкратце, final используется для объявления однократно инициализируемой переменной времени выполнения,
  // в то время как const используется для объявления значения времени компиляции,
  // которое не может быть изменено после инициализации.


  // Так же дополнение. Константа, которая определена через final разрешает изменять свое внутреннее состояние
  final a = [1,2,3];
  a.add(4);
  

  

}